#pragma once

#include "CoreMinimal.h"
#include "ActorNavMovementComponent.h"
#include "AITypes.h"
#include "Templates/SubclassOf.h"
#include "DBDTunableRowHandle.h"
#include "CoreMemoryNavMovementComponent.generated.h"

class UNavigationQueryFilter;
class UCoreMemoryFragmentNavAgentComponent;

UCLASS(Blueprintable, meta=(BlueprintSpawnableComponent))
class UCoreMemoryNavMovementComponent : public UActorNavMovementComponent
{
	GENERATED_BODY()

private:
	UPROPERTY(EditInstanceOnly, Transient)
	FAIMoveRequest _moveRequest;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	TSubclassOf<UNavigationQueryFilter> _navFilter;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _movementAcceptanceRadius;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	FDBDTunableRowHandle _fragmentMoveSpeed;

	UPROPERTY(EditInstanceOnly, BlueprintReadWrite, Transient, Instanced, meta=(AllowPrivateAccess=true))
	UCoreMemoryFragmentNavAgentComponent* _navAgentComponent;

public:
	UCoreMemoryNavMovementComponent();
};

FORCEINLINE uint32 GetTypeHash(const UCoreMemoryNavMovementComponent) { return 0; }
